import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load, load_module, reload_module, get_stdout, check_source
from functools import reduce
import os
import textwrap

exercise = 'src.all_longest_in_list'
function = 'all_the_longest'

def get_correct(test_case: list) -> list:
    pass

@points('1.all_longest_in_list')
class AllLongestInListTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
           cls.module = load_module(exercise, 'en')

    def test_0_paaohjelma_kunnossa(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test_1_function_exists(self):
        try:
            from src.all_longest_in_list import all_the_longest
        except:
            self.assertTrue(False, 'Din kod bör innehålla en funktion som heter all_the_longest(my_list: list)')
        try:
            all_the_longest = load(exercise, function, 'en')
            all_the_longest(["abc", "ab"])
        except:
            self.assertTrue(False, 'Testa funktionsanrop\nall_the_longest(["abc", "ab"])')


    def test_2_type_of_return_value(self):
        all_the_longest = load(exercise, function, 'en')
        val = all_the_longest(["Adam", "Grace"])
        self.assertTrue(type(val) == list, f"Funktionen {function} returnerar inte lista med parametervärden ['Adam', 'Grace'].")
    
    def test_3_one_longest(self):
        test_cases = {("Alan", "Steve", "Seymour", "Kim", "Susan") : ["Seymour"], 
                      ("Paul", "Ruth", "Magdalena", "Jean", "Larry") : ["Magdalena"],
                      ("Seraenina", "Gandalf", "Harry", "Walter") : ["Seraenina"]}
        for test_case in test_cases:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                output_at_start = get_stdout()
                all_the_longest = load(exercise, function, 'en')
                
                correct = test_cases[test_case]
                test_case2 = test_case[:]
                test_result = all_the_longest(list(test_case))

                self.assertEqual(correct, test_result, f"Resultatet {test_result} matchar inte det förväntade resultatet {correct} när all_the_longest({test_case2}) anropas")
                self.assertEqual(test_case, test_case2, f"Funktionen bör inte ändra den ursprungliga listan. Listan ska vara {list(test_case2)} men den är {list(test_case)}.")

    def test_4_several_longest(self):
        test_cases = {("Alan", "Grace", "Steve", "Kim", "Susan") : ["Grace", "Steve", "Susan"], 
                      ("Mark", "Paul", "Bill", "Jan", "Tim", "Jean") : ["Mark", "Paul", "Bill", "Jean"],
                      ("Huey", "Dewey", "Louie", "April", "May", "June", "David") : ["Dewey", "Louie", "April", "David"]}
        for test_case in test_cases:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                output_at_start = get_stdout()
                all_the_longest = load(exercise, function, 'en')
                
                correct = test_cases[test_case]
                test_case2 = test_case[:]
                test_result = all_the_longest(list(test_case))

                self.assertEqual(correct, test_result, f"Resultatet {test_result} matchar inte det förväntade resultatet {correct} när all_the_longest({test_case2}) anropas")
                self.assertEqual(test_case, test_case2, f"Funktionen bör inte ändra den ursprungliga listan. Listan ska vara {list(test_case2)} men den är {list(test_case)}.")

if __name__ == '__main__':
    unittest.main()